/*
 * n01_score
 *
 * window.h
 *
 * Copyright (C) 1996-2007 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_N01_WINDOW_H
#define _INC_N01_WINDOW_H

/* Include Files */
#include "..\n01_plugin.h"

/* Define */
#define WM_SCORE_DRAW_INIT			(WM_APP + 1)
#define WM_SCORE_REDRAW				(WM_APP + 2)
#define WM_SCORE_REDRAW_DELAY		(WM_APP + 3)

/* Struct */
typedef struct _OPTION {
	RECT window_rect;

	TCHAR font_name[BUF_SIZE];
	int name_font_size;

	int visible_set;
	int size_width;
	int full_screen;

	COLORREF line_color;

	COLORREF head_text;
	COLORREF name_text;
	COLORREF name_back;
	COLORREF sets_text;
	COLORREF sets_back;
	COLORREF legs_text;
	COLORREF legs_back;
	COLORREF score_text;
	COLORREF score_back;

	TCHAR back_bmp[BUF_SIZE];
	TCHAR num_l_bmp[BUF_SIZE];
	TCHAR num_s_bmp[BUF_SIZE];
	int name_left[2];
	int name_top[2];
	int name_right[2];
	int name_bottom[2];
	int score_x[2];
	int score_y[2];
	int sets_x[2];
	int sets_y[2];
	int legs_x[2];
	int legs_y[2];

	TCHAR score_title[BUF_SIZE];

	RECT score_window_rect;

	TCHAR score_font_name[BUF_SIZE];

	int score_visible_set;
	int score_line_width;
	int score_size_width;

	COLORREF score_line_color;
	COLORREF score_first_mark;
	COLORREF score_head_text;
	COLORREF score_head_back;
	COLORREF score_name_text;
	COLORREF score_name_back;
	COLORREF score_sets_text;
	COLORREF score_sets_back;
	COLORREF score_legs_text;
	COLORREF score_legs_back;
	COLORREF score_score_text;
	COLORREF score_score_back;
	COLORREF score_current_mark;
	COLORREF score_current_back;

	RECT reslut_rect;
	TCHAR reslut_font_name[BUF_SIZE];
	int reslut_line_width;
	int reslut_size_width;
	int reslut_full_screen;
	COLORREF reslut_line_color;
	COLORREF reslut_head_back;
	COLORREF reslut_body_back;
	COLORREF reslut_head_text;
	COLORREF reslut_title_text;
	COLORREF reslut_stats_text;
	int avg_per_round;
} OPTION;

/* Function Prototypes */
BOOL view_window_regist(const HINSTANCE hInstance);
HWND view_window_create(const HINSTANCE hInstance, SCORE_INFO *si);

#endif
/* End of source */
